// program som använder en vector för att räkna förekomsten av tecken
// i en text och skriver ut dem i bokstavsordning
#include <iterator>
#include <algorithm>
#include <iostream>
#include <vector>
#include <utility>
#include <cctype>
using namespace std;

int main()
{
    vector<pair<char, int>> characters;
    for ( char c; cin.get(c); )
    {
        c = tolower(c);
        // lower_bound hittar första elementet som är större eller
        // lika med det vi söker efter (c). I detta anrop måste vi
        // skicka med ett lambda som jämför eftersom vectorn inte
        // innehåller char
        auto it { lower_bound(begin(characters), end(characters), c,
                [](pair<char,int> p, char c) { return p.first < c; })};
        // om vi inte hittade något värde är it samma som end, annars
        // vill vi antingen stoppa in ett nytt pair eller öka räknaren
        if ( it == characters.end() || it->first != c )
        {
            characters.insert(it, make_pair(c, 1));
        }
        else
        {
            it->second++;
        }
    }
    for ( auto p: characters )
    {
        cout << p.first << ": " << p.second << '\n';
    }

}
