// kort program som läser in ett valfritt antal tal, sorterar dem
// och skriver ut talen i stigande ordning.
#include <algorithm>
#include <iostream>
#include <vector>
#include <iterator>
using namespace std;


int main()
{
    // en istream_iterator kopplar en ström till en iterator så att
    // värden läses in formaterat (med >>) internt i iteratorn när 
    // den stegas. Vid avreferering får man det senast lästa värdet.
    // En istream_iterator som inte är kopplad till en ström jämförs
    // lika med en iterator som nått slutet (eller fått någon annan
    // felflagga satt) i sin ström. Här läser vi alltså in alla värden
    // i cin och lagrar dem direkt i values.
    vector<int> values { istream_iterator<int>{cin},
                         istream_iterator<int>{} };
    sort(begin(values), end(values)); 
    cout << values.size();
    // På samma sätt finns ostream_iterator för att skriva ut saker på
    // en ström. Det andra argumentet är en delimiter, dvs en sträng
    // som skrivs ut efter varje värde.
    copy(begin(values), end(values),
            ostream_iterator<int>{cout,"\n"});
}
