#include "optional.h"

#include <utility>

Optional::Optional(int i)
    : data{new int{i}}
{}
Optional::Optional(Optional const & o)
{
    if (o.has_value())
    {
        data = new int{*o};
    }
}
Optional & Optional::operator=(Optional const & o)&
{
    Optional{o}.swap(*this);
    return *this;
}
Optional & Optional::operator=(int i)&
{
    if ( !has_value() )
    {
        data = new int{};
    }
    *data = i;
    return *this;
}

Optional::Optional(no_value_t) noexcept: data{} {}

Optional& Optional::operator=(no_value_t) noexcept
{
    reset();
    return *this;
}

int & Optional::value()
{
    if ( !has_value() )
        throw no_value_error{"No value!"};
    return *data;
}
int const & Optional::value() const
{
    if ( !has_value() )
        throw no_value_error{"No value!"};
    return *data;
}
Optional::operator bool() const
{
    return has_value();
}
bool Optional::has_value() const
{
    return data != nullptr;
}
int const & Optional::operator*() const noexcept
{
    return *data;
}
int & Optional::operator*() noexcept
{
    return *data;
}
void Optional::swap(Optional & o)
{
    using std::swap;
    swap(data, o.data);
}
void Optional::reset()
{
    delete data;
    data = nullptr;
}

