#include <memory>
using namespace std;

// requires the user to explicitly move the resouce at call site.
void take_resource(unique_ptr<int> p) {}

int main()
{
    unique_ptr<int> p1;
    // make_unique takes the arguments required by the constructor of the stored type
    p1 = make_unique<int>(5);
    p1 = make_unique<int>(6);
    unique_ptr<int> p2 { new int{2} };
    p1 = move(p2);
    
    // get access to (but not ownership of) resource
    int * ptr = p1.get();
    
    // Here both p1 and p3 beleives that they own the pointer... BAD!
    //unique_ptr<int> p3 { p1.get() };
    
    // Instead we move construct.
    unique_ptr<int> p3 { move(p1) };
    take_resource(move(p3));
}
