// We create a function that calls push_back on a given container

#include <vector>
#include <string>
using namespace std;

// we want val to be of the type of the values that are stored
// in the container. All STL containers have a member type called
// value_type. Container::value_type is a dependent name (could be
// many things, not only a type) and the compiler isn't (at the moment) allowed
// to assume that it is a type -> we have to explicitly state that
// it is the name of a type (typename). 
// using class or typename in the template parameter declaration doesn't matter
template <class Container>
void push(Container & v, typename Container::value_type val)
{
    v.push_back(val);
}


int main()
{
    vector<int> vals;
    push(vals, 3);
    vector<string> s;
    push(s, "hej");
    // doesn't compile...
    //push(vals, "hejsan");
}
